diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/radiotap-header.cc ns-3.47/src/network/utils/radiotap-header.cc
--- ns-3.46/src/network/utils/radiotap-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/radiotap-header.cc	2026-02-16 16:08:49.806230800 -0800
@@ -764,10 +730,13 @@
 uint32_t
 RadiotapHeader::DeserializeMcs(Buffer::Iterator start, uint32_t bytesRead)
 {
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_mcsPad = GetPadding(bytesRead, RADIOTAP_MCS_ALIGNMENT_B);
+    start.Next(m_mcsPad);
     m_mcsFields.known = start.ReadU8();
     m_mcsFields.flags = start.ReadU8();
     m_mcsFields.mcs = start.ReadU8();
-    return sizeof(McsFields);
+    return RADIOTAP_MCS_SIZE_B + m_mcsPad;
 }
 
 void
@@ -782,20 +751,19 @@
 {
     NS_LOG_FUNCTION(this << ampduStatusFields.referenceNumber << ampduStatusFields.flags);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_AMPDU_STATUS),
-                  "A-MPDU status radiotap field already present");
-    m_ampduStatusPad = ((4 - m_length % 4) % 4);
-    m_present.at(0) |= RADIOTAP_AMPDU_STATUS;
-    m_length += (sizeof(ampduStatusFields) + m_ampduStatusPad);
+    UpdatePresentField(RADIOTAP_AMPDU_STATUS);
+    m_ampduStatusPad = GetPadding(m_length, RADIOTAP_AMPDU_STATUS_ALIGNMENT_B);
+    m_length += RADIOTAP_AMPDU_STATUS_SIZE_B + m_ampduStatusPad;
     m_ampduStatusFields = ampduStatusFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeAmpduStatus(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_ampduStatusPad);
     start.WriteU32(m_ampduStatusFields.referenceNumber);
     start.WriteU16(m_ampduStatusFields.flags);
@@ -806,13 +774,14 @@
 uint32_t
 RadiotapHeader::DeserializeAmpduStatus(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_ampduStatusPad = ((4 - bytesRead % 4) % 4);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_ampduStatusPad = GetPadding(bytesRead, RADIOTAP_AMPDU_STATUS_ALIGNMENT_B);
     start.Next(m_ampduStatusPad);
     m_ampduStatusFields.referenceNumber = start.ReadU32();
     m_ampduStatusFields.flags = start.ReadU16();
     m_ampduStatusFields.crc = start.ReadU8();
     m_ampduStatusFields.reserved = start.ReadU8();
-    return sizeof(AmpduStatusFields) + m_ampduStatusPad;
+    return RADIOTAP_AMPDU_STATUS_SIZE_B + m_ampduStatusPad;
 }
 
 void
@@ -824,24 +793,24 @@
 void
 RadiotapHeader::SetVhtFields(const VhtFields& vhtFields)
 {
-    NS_LOG_FUNCTION(this << vhtFields.known << vhtFields.flags << +vhtFields.mcsNss.at(0)
-                         << +vhtFields.mcsNss.at(1) << +vhtFields.mcsNss.at(2)
-                         << +vhtFields.mcsNss.at(3) << +vhtFields.coding << +vhtFields.groupId
-                         << +vhtFields.partialAid);
-
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_VHT), "VHT radiotap field already present");
-    m_vhtPad = ((2 - m_length % 2) % 2);
-    m_present.at(0) |= RADIOTAP_VHT;
-    m_length += (sizeof(VhtFields) + m_vhtPad);
+    NS_LOG_FUNCTION(this << vhtFields.known << vhtFields.flags << vhtFields.mcsNss.at(0)
+                         << vhtFields.mcsNss.at(1) << vhtFields.mcsNss.at(2)
+                         << vhtFields.mcsNss.at(3) << vhtFields.coding << vhtFields.groupId
+                         << vhtFields.partialAid);
+
+    UpdatePresentField(RADIOTAP_VHT);
+    m_vhtPad = GetPadding(m_length, RADIOTAP_VHT_ALIGNMENT_B);
+    m_length += RADIOTAP_VHT_SIZE_B + m_vhtPad;
     m_vhtFields = vhtFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeVht(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_vhtPad);
     start.WriteU16(m_vhtFields.known);
     start.WriteU8(m_vhtFields.flags);
@@ -858,7 +827,8 @@
 uint32_t
 RadiotapHeader::DeserializeVht(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_vhtPad = ((2 - bytesRead % 2) % 2);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_vhtPad = GetPadding(bytesRead, RADIOTAP_VHT_ALIGNMENT_B);
     start.Next(m_vhtPad);
     m_vhtFields.known = start.ReadU16();
     m_vhtFields.flags = start.ReadU8();
@@ -870,19 +840,20 @@
     m_vhtFields.coding = start.ReadU8();
     m_vhtFields.groupId = start.ReadU8();
     m_vhtFields.partialAid = start.ReadU16();
-    return sizeof(VhtFields) + m_vhtPad;
+    return RADIOTAP_VHT_SIZE_B + m_vhtPad;
 }
 
 void
 RadiotapHeader::PrintVht(std::ostream& os) const
 {
     os << " vht.known=0x" << m_vhtFields.known << " vht.flags=0x" << m_vhtFields.flags
-       << " vht.bandwidth=" << std::dec << m_vhtFields.bandwidth
-       << " vht.mcsNss[0]=" << +m_vhtFields.mcsNss.at(0)
-       << " vht.mcsNss[1]=" << +m_vhtFields.mcsNss.at(1)
-       << " vht.mcsNss[2]=" << +m_vhtFields.mcsNss.at(2)
-       << " vht.mcsNss[3]=" << +m_vhtFields.mcsNss.at(3) << " vht.coding=" << m_vhtFields.coding
-       << " vht.groupId=" << m_vhtFields.groupId << " vht.partialAid=" << m_vhtFields.partialAid;
+       << " vht.bandwidth=" << std::dec << m_vhtFields.bandwidth;
+    for (std::size_t i = 0; i < m_vhtFields.mcsNss.size(); ++i)
+    {
+        os << " vht.mcsNss[" << i << "]=" << +m_vhtFields.mcsNss.at(i);
+    }
+    os << " vht.coding=" << m_vhtFields.coding << " vht.groupId=" << m_vhtFields.groupId
+       << " vht.partialAid=" << m_vhtFields.partialAid;
 }
 
 void
@@ -891,19 +862,19 @@
     NS_LOG_FUNCTION(this << heFields.data1 << heFields.data2 << heFields.data3 << heFields.data4
                          << heFields.data5 << heFields.data6);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_HE), "HE radiotap field already present");
-    m_hePad = ((2 - m_length % 2) % 2);
-    m_present.at(0) |= RADIOTAP_HE;
-    m_length += (sizeof(heFields) + m_hePad);
+    UpdatePresentField(RADIOTAP_HE);
+    m_hePad = GetPadding(m_length, RADIOTAP_HE_ALIGNMENT_B);
+    m_length += RADIOTAP_HE_SIZE_B + m_hePad;
     m_heFields = heFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeHe(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_hePad);
     start.WriteU16(m_heFields.data1);
     start.WriteU16(m_heFields.data2);
@@ -916,7 +887,8 @@
 uint32_t
 RadiotapHeader::DeserializeHe(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_hePad = ((2 - bytesRead % 2) % 2);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_hePad = GetPadding(bytesRead, RADIOTAP_HE_ALIGNMENT_B);
     start.Next(m_hePad);
     m_heFields.data1 = start.ReadU16();
     m_heFields.data2 = start.ReadU16();
@@ -924,7 +896,7 @@
     m_heFields.data4 = start.ReadU16();
     m_heFields.data5 = start.ReadU16();
     m_heFields.data6 = start.ReadU16();
-    return sizeof(HeFields) + m_hePad;
+    return RADIOTAP_HE_SIZE_B + m_hePad;
 }
 
 void
@@ -941,19 +913,19 @@
 {
     NS_LOG_FUNCTION(this << heMuFields.flags1 << heMuFields.flags2);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_HE_MU), "HE-MU radiotap field already present");
-    m_heMuPad = ((2 - m_length % 2) % 2);
-    m_present.at(0) |= RADIOTAP_HE_MU;
-    m_length += (sizeof(heMuFields) + m_heMuPad);
+    UpdatePresentField(RADIOTAP_HE_MU);
+    m_heMuPad = GetPadding(m_length, RADIOTAP_HE_MU_ALIGNMENT_B);
+    m_length += RADIOTAP_HE_MU_SIZE_B + m_heMuPad;
     m_heMuFields = heMuFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                             << std::dec);
 }
 
 void
 RadiotapHeader::SerializeHeMu(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_heMuPad);
     start.WriteU16(m_heMuFields.flags1);
     start.WriteU16(m_heMuFields.flags2);
@@ -970,7 +942,8 @@
 uint32_t
 RadiotapHeader::DeserializeHeMu(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_heMuPad = ((2 - bytesRead % 2) % 2);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_heMuPad = GetPadding(bytesRead, RADIOTAP_HE_MU_ALIGNMENT_B);
     start.Next(m_heMuPad);
     m_heMuFields.flags1 = start.ReadU16();
     m_heMuFields.flags2 = start.ReadU16();
@@ -982,7 +955,7 @@
     {
         ruChannel = start.ReadU8();
     }
-    return sizeof(HeMuFields) + m_heMuPad;
+    return RADIOTAP_HE_MU_SIZE_B + m_heMuPad;
 }
 
 void
@@ -996,23 +969,22 @@
 RadiotapHeader::SetHeMuOtherUserFields(const HeMuOtherUserFields& heMuOtherUserFields)
 {
     NS_LOG_FUNCTION(this << heMuOtherUserFields.perUser1 << heMuOtherUserFields.perUser2
-                         << +heMuOtherUserFields.perUserPosition
-                         << +heMuOtherUserFields.perUserKnown);
+                         << heMuOtherUserFields.perUserPosition
+                         << heMuOtherUserFields.perUserKnown);
 
-    NS_ASSERT_MSG(!(m_present.at(0) & RADIOTAP_HE_MU_OTHER_USER),
-                  "HE-MU-other-user radiotap field already present");
-    m_heMuOtherUserPad = ((2 - m_length % 2) % 2);
-    m_present.at(0) |= RADIOTAP_HE_MU_OTHER_USER;
-    m_length += (sizeof(HeMuOtherUserFields) + m_heMuOtherUserPad);
+    UpdatePresentField(RADIOTAP_HE_MU_OTHER_USER);
+    m_heMuOtherUserPad = GetPadding(m_length, RADIOTAP_HE_MU_OTHER_USER_ALIGNMENT_B);
+    m_length += RADIOTAP_HE_MU_OTHER_USER_SIZE_B + m_heMuOtherUserPad;
     m_heMuOtherUserFields = heMuOtherUserFields;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
-                      << std::dec);
+    NS_LOG_LOGIC(" m_length=" << m_length << " m_present=0x" << std::hex << m_present.at(0)
+                              << std::dec);
 }
 
 void
 RadiotapHeader::SerializeHeMuOtherUser(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_heMuOtherUserPad);
     start.WriteU16(m_heMuOtherUserFields.perUser1);
     start.WriteU16(m_heMuOtherUserFields.perUser2);
@@ -1023,13 +995,14 @@
 uint32_t
 RadiotapHeader::DeserializeHeMuOtherUser(Buffer::Iterator start, uint32_t bytesRead)
 {
-    m_heMuOtherUserPad = ((2 - bytesRead % 2) % 2);
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+    m_heMuOtherUserPad = GetPadding(bytesRead, RADIOTAP_HE_MU_OTHER_USER_ALIGNMENT_B);
     start.Next(m_heMuOtherUserPad);
     m_heMuOtherUserFields.perUser1 = start.ReadU16();
     m_heMuOtherUserFields.perUser2 = start.ReadU16();
     m_heMuOtherUserFields.perUserPosition = start.ReadU8();
     m_heMuOtherUserFields.perUserKnown = start.ReadU8();
-    return sizeof(HeMuOtherUserFields) + m_heMuOtherUserPad;
+    return RADIOTAP_HE_MU_OTHER_USER_SIZE_B + m_heMuOtherUserPad;
 }
 
 void
@@ -1046,29 +1019,26 @@
 RadiotapHeader::SetUsigFields(const UsigFields& usigFields)
 {
     NS_LOG_FUNCTION(this << usigFields.common << usigFields.mask << usigFields.value);
-    NS_ASSERT_MSG(m_present.size() >= 2,
-                  "Number of it_present words (" << m_present.size() << ") is incorrect");
-    m_present.at(0) |= RADIOTAP_TLV;
-
-    NS_ASSERT_MSG(!(m_present.at(1) & RADIOTAP_USIG), "U-SIG radiotap field already present");
-    m_present.at(1) |= RADIOTAP_USIG;
-
-    m_usigTlvPad = ((8 - m_length % 8) % 8);
-    m_usigTlv.type = 32 + std::countr_zero<uint16_t>(RADIOTAP_USIG);
-    m_usigTlv.length = sizeof(UsigFields);
-    m_length += sizeof(TlvFields) + m_usigTlvPad;
 
-    m_usigPad = ((4 - m_length % 4) % 4);
+    UpdatePresentField(RADIOTAP_TLV);
+    m_usigTlvPad = GetPadding(m_length, RADIOTAP_TLV_ALIGNMENT_B);
+    m_usigTlv.type = RADIOTAP_USIG;
+    m_usigTlv.length = RADIOTAP_USIG_SIZE_B;
+    m_length += RADIOTAP_TLV_HEADER_SIZE_B + m_usigTlvPad;
+
+    UpdatePresentField(RADIOTAP_USIG);
+    m_usigPad = GetPadding(m_length, RADIOTAP_USIG_ALIGNMENT_B);
     m_usigFields = usigFields;
     m_length += m_usigTlv.length + m_usigPad;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present[0]=0x" << std::hex
-                      << m_present.at(0) << " m_present[1]=0x" << m_present.at(1) << std::dec);
+    NS_LOG_LOGIC(" m_length=" << m_length << " m_present[0]=0x" << std::hex << m_present.at(0)
+                              << " m_present[1]=0x" << m_present.at(1) << std::dec);
 }
 
 void
 RadiotapHeader::SerializeUsig(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_usigTlvPad);
     start.WriteU16(m_usigTlv.type);
     start.WriteU16(m_usigTlv.length);
@@ -1081,20 +1051,21 @@
 uint32_t
 RadiotapHeader::DeserializeUsig(Buffer::Iterator start, uint32_t bytesRead)
 {
+    NS_LOG_FUNCTION(this << &start << bytesRead);
     const auto startBytesRead = bytesRead;
-    m_usigTlvPad = ((8 - bytesRead % 8) % 8);
+    m_usigTlvPad = GetPadding(bytesRead, RADIOTAP_TLV_ALIGNMENT_B);
     start.Next(m_usigTlvPad);
     bytesRead += m_usigTlvPad;
     m_usigTlv.type = start.ReadU16();
     m_usigTlv.length = start.ReadU16();
-    bytesRead += sizeof(TlvFields);
-    m_usigPad = ((4 - bytesRead % 4) % 4);
+    bytesRead += RADIOTAP_TLV_HEADER_SIZE_B;
+    m_usigPad = GetPadding(bytesRead, RADIOTAP_USIG_ALIGNMENT_B);
     start.Next(m_usigPad);
     bytesRead += m_usigPad;
     m_usigFields.common = start.ReadU32();
     m_usigFields.value = start.ReadU32();
     m_usigFields.mask = start.ReadU32();
-    bytesRead += sizeof(UsigFields);
+    bytesRead += RADIOTAP_USIG_SIZE_B;
     return bytesRead - startBytesRead;
 }
 
@@ -1109,29 +1080,28 @@
 RadiotapHeader::SetEhtFields(const EhtFields& ehtFields)
 {
     NS_LOG_FUNCTION(this << ehtFields.known);
-    NS_ASSERT_MSG(m_present.size() >= 2,
-                  "Number of it_present words (" << m_present.size() << ") is incorrect");
-    m_present.at(0) |= RADIOTAP_TLV;
-
-    NS_ASSERT_MSG(!(m_present.at(1) & RADIOTAP_EHT_SIG), "EHT radiotap field already present");
-    m_present.at(1) |= RADIOTAP_EHT_SIG;
-
-    m_ehtTlvPad = ((8 - m_length % 8) % 8);
-    m_ehtTlv.type = 32 + std::countr_zero<uint16_t>(RADIOTAP_EHT_SIG);
-    m_ehtTlv.length = (40 + ehtFields.userInfo.size() * 4);
-    m_length += sizeof(TlvFields) + m_ehtTlvPad;
 
-    m_ehtPad = ((4 - m_length % 4) % 4);
+    UpdatePresentField(RADIOTAP_TLV);
+    m_ehtTlvPad = GetPadding(m_length, RADIOTAP_TLV_ALIGNMENT_B);
+    m_ehtTlv.type = RADIOTAP_EHT;
+    m_ehtTlv.length = RADIOTAP_EHT_KNOWN_SIZE_B +
+                      (RADIOTAP_EHT_DATA_SIZE_B * ehtFields.data.size()) +
+                      (ehtFields.userInfo.size() * RADIOTAP_EHT_USER_INFO_SIZE_B);
+    m_length += RADIOTAP_TLV_HEADER_SIZE_B + m_ehtTlvPad;
+
+    UpdatePresentField(RADIOTAP_EHT);
+    m_ehtPad = GetPadding(m_length, RADIOTAP_EHT_ALIGNMENT_B);
     m_ehtFields = ehtFields;
     m_length += m_ehtTlv.length + m_ehtPad;
 
-    NS_LOG_LOGIC(this << " m_length=" << m_length << " m_present[0]=0x" << std::hex
-                      << m_present.at(0) << " m_present[1]=0x" << m_present.at(1) << std::dec);
+    NS_LOG_LOGIC("m_length=" << m_length << " m_present[0]=0x" << std::hex << m_present.at(0)
+                             << " m_present[1]=0x" << m_present.at(1) << std::dec);
 }
 
 void
 RadiotapHeader::SerializeEht(Buffer::Iterator& start) const
 {
+    NS_LOG_FUNCTION(this << &start);
     start.WriteU8(0, m_ehtTlvPad);
     start.WriteU16(m_ehtTlv.type);
     start.WriteU16(m_ehtTlv.length);
@@ -1150,32 +1120,34 @@
 uint32_t
 RadiotapHeader::DeserializeEht(Buffer::Iterator start, uint32_t bytesRead)
 {
+    NS_LOG_FUNCTION(this << &start << bytesRead);
+
     const auto startBytesRead = bytesRead;
 
-    m_ehtTlvPad = ((8 - bytesRead % 8) % 8);
+    m_ehtTlvPad = GetPadding(bytesRead, RADIOTAP_TLV_ALIGNMENT_B);
     start.Next(m_ehtTlvPad);
     bytesRead += m_ehtTlvPad;
     m_ehtTlv.type = start.ReadU16();
     m_ehtTlv.length = start.ReadU16();
-    bytesRead += sizeof(TlvFields);
+    bytesRead += RADIOTAP_TLV_HEADER_SIZE_B;
 
-    m_ehtPad = ((4 - bytesRead % 4) % 4);
+    m_ehtPad = GetPadding(bytesRead, RADIOTAP_EHT_ALIGNMENT_B);
     start.Next(m_ehtPad);
     bytesRead += m_ehtPad;
     m_ehtFields.known = start.ReadU32();
-    bytesRead += 4;
+    bytesRead += RADIOTAP_EHT_KNOWN_SIZE_B;
     for (auto& dataField : m_ehtFields.data)
     {
         dataField = start.ReadU32();
-        bytesRead += 4;
+        bytesRead += RADIOTAP_EHT_DATA_SIZE_B;
     }
     const auto userInfosBytes = m_ehtTlv.length - bytesRead - m_ehtTlvPad;
-    NS_ASSERT(userInfosBytes % 4 == 0);
-    const std::size_t numUsers = userInfosBytes / 4;
+    NS_ASSERT(userInfosBytes % RADIOTAP_EHT_USER_INFO_SIZE_B == 0);
+    const std::size_t numUsers = userInfosBytes / RADIOTAP_EHT_USER_INFO_SIZE_B;
     for (std::size_t i = 0; i < numUsers; ++i)
     {
         m_ehtFields.userInfo.push_back(start.ReadU32());
-        bytesRead += 4;
+        bytesRead += RADIOTAP_EHT_USER_INFO_SIZE_B;
     }
 
     return bytesRead - startBytesRead;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/radiotap-header.h ns-3.47/src/network/utils/radiotap-header.h
--- ns-3.46/src/network/utils/radiotap-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/radiotap-header.h	2026-02-16 16:08:49.806230800 -0800
@@ -30,7 +30,6 @@
 class RadiotapHeader : public Header
 {
   public:
-    RadiotapHeader();
     /**
      * @brief Get the type ID.
      * @returns the object TypeId
@@ -784,6 +783,13 @@
     static constexpr int MIN_HEADER_SIZE{8}; //!< the minimum size of the radiotap header
 
     /**
+     * Update a present field.
+     *
+     * @param field The field to set in a present bitmask.
+     */
+    void UpdatePresentField(uint32_t field);
+
+    /**
      * Serialize the TSFT radiotap header.
      *
      * @param start An iterator which points to where the header should be written.
@@ -1017,45 +1023,26 @@
     void PrintEht(std::ostream& os) const;
 
     /**
-     * @brief Radiotap flags.
+     * @brief Radiotap fields.
      */
-    enum RadiotapFlags : uint32_t
+    enum RadiotapFields : uint32_t
     {
-        RADIOTAP_TSFT = 0x00000001,
-        RADIOTAP_FLAGS = 0x00000002,
-        RADIOTAP_RATE = 0x00000004,
-        RADIOTAP_CHANNEL = 0x00000008,
-        RADIOTAP_FHSS = 0x00000010,
-        RADIOTAP_DBM_ANTSIGNAL = 0x00000020,
-        RADIOTAP_DBM_ANTNOISE = 0x00000040,
-        RADIOTAP_LOCK_QUALITY = 0x00000080,
-        RADIOTAP_TX_ATTENUATION = 0x00000100,
-        RADIOTAP_DB_TX_ATTENUATION = 0x00000200,
-        RADIOTAP_DBM_TX_POWER = 0x00000400,
-        RADIOTAP_ANTENNA = 0x00000800,
-        RADIOTAP_DB_ANTSIGNAL = 0x00001000,
-        RADIOTAP_DB_ANTNOISE = 0x00002000,
-        RADIOTAP_RX_FLAGS = 0x00004000,
-        RADIOTAP_MCS = 0x00080000,
-        RADIOTAP_AMPDU_STATUS = 0x00100000,
-        RADIOTAP_VHT = 0x00200000,
-        RADIOTAP_HE = 0x00800000,
-        RADIOTAP_HE_MU = 0x01000000,
-        RADIOTAP_HE_MU_OTHER_USER = 0x02000000,
-        RADIOTAP_ZERO_LEN_PSDU = 0x04000000,
-        RADIOTAP_LSIG = 0x08000000,
-        RADIOTAP_TLV = 0x10000000,
-        RADIOTAP_EXT = 0x80000000
-    };
-
-    /**
-     * @brief Radiotap extended flags.
-     */
-    enum RadiotapExtFlags : uint32_t
-    {
-        RADIOTAP_S1G = 0x00000001,
-        RADIOTAP_USIG = 0x00000002,
-        RADIOTAP_EHT_SIG = 0x00000004
+        RADIOTAP_TSFT = 0,
+        RADIOTAP_FLAGS = 1,
+        RADIOTAP_RATE = 2,
+        RADIOTAP_CHANNEL = 3,
+        RADIOTAP_DBM_ANTSIGNAL = 5,
+        RADIOTAP_DBM_ANTNOISE = 6,
+        RADIOTAP_MCS = 19,
+        RADIOTAP_AMPDU_STATUS = 20,
+        RADIOTAP_VHT = 21,
+        RADIOTAP_HE = 23,
+        RADIOTAP_HE_MU = 24,
+        RADIOTAP_HE_MU_OTHER_USER = 25,
+        RADIOTAP_TLV = 28,
+        RADIOTAP_MORE_PRESENT = 31, // indicates that another 32 bits of present flags follow
+        RADIOTAP_USIG = 33,
+        RADIOTAP_EHT = 34,
     };
 
     uint16_t m_length{MIN_HEADER_SIZE}; //!< entire length of radiotap data + header
@@ -1077,6 +1064,7 @@
     int8_t m_antennaNoise{
         0}; //!< RF noise power at the antenna, dB difference from an arbitrary, fixed reference.
 
+    uint8_t m_mcsPad{0};     //!< MCS padding.
     McsFields m_mcsFields{}; //!< MCS fields.
 
     uint8_t m_ampduStatusPad{0}; //!< A-MPDU Status Flags, padding before A-MPDU Status Field.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/network/utils/sequence-number.h ns-3.47/src/network/utils/sequence-number.h
--- ns-3.46/src/network/utils/sequence-number.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/network/utils/sequence-number.h	2026-02-16 16:08:49.806230800 -0800
@@ -11,6 +11,7 @@
 
 #include "ns3/type-name.h"
 
+#include <compare>
 #include <iostream>
 #include <limits>
 #include <stdint.h>
@@ -256,73 +257,45 @@
     }
 
     /**
-     * Here is the critical part, how the comparison is made taking into
-     * account wrap-around.  From RFC 3626:
-     *
-     * The sequence number S1 is said to be "greater than" the sequence
-     * number S2 if:
-     *      S1 > S2 AND S1 - S2 <= MAXVALUE/2 OR
-     *      S2 > S1 AND S2 - S1 > MAXVALUE/2
-     *
-     * @param other sequence number to compare to this one
-     * @returns true if this sequence number is greater than other
-     */
-    bool operator>(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
-    {
-        static const NUMERIC_TYPE halfMaxValue = std::numeric_limits<NUMERIC_TYPE>::max() / 2;
-
-        return (((m_value > other.m_value) && (m_value - other.m_value) <= halfMaxValue) ||
-                ((other.m_value > m_value) && (other.m_value - m_value) > halfMaxValue));
-    }
-
-    /**
      * @brief Equality operator for comparing sequence number
      * @param other sequence number to compare to this sequence number
      * @returns true if the sequence numbers are equal
      */
-    bool operator==(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
+    constexpr bool operator==(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
     {
         return m_value == other.m_value;
     }
 
     /**
-     * @brief Inequality operator for comparing sequence numbers
-     * @param other sequence number to compare to this sequence number
-     * @returns true if the sequence numbers are not equal
-     */
-    bool operator!=(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
-    {
-        return m_value != other.m_value;
-    }
-
-    /**
-     * @brief Less than or equal operator for comparing sequence numbers
-     * @param other sequence number to compare to this sequence number
-     * @returns true if this sequence number is less than or equal to other
-     */
-    bool operator<=(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
-    {
-        return (!this->operator>(other));
-    }
-
-    /**
-     * @brief Greater than or equal operator for comparing sequence numbers
-     * @param other sequence number to compare to this sequence number
-     * @returns true if this sequence number is greater than or equal to other
+     * Spaceship comparison operator. All the other comparison operators
+     * are automatically generated from this one.
+     *
+     * Here is the critical part, how the comparison is made taking into
+     * account wrap-around. From RFC 3626:
+     *
+     * The sequence number S1 is said to be "greater than" the sequence
+     * number S2 if:
+     *      S1 > S2 AND S1 - S2 <= MAXVALUE/2 OR
+     *      S2 > S1 AND S2 - S1 > MAXVALUE/2
+     *
+     * @param other sequence number to compare to this one
+     * @returns The result of the comparison.
      */
-    bool operator>=(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
+    constexpr std::strong_ordering operator<=>(
+        const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
     {
-        return (this->operator>(other) || this->operator==(other));
-    }
+        constexpr auto halfMaxValue = std::numeric_limits<NUMERIC_TYPE>::max() / 2;
 
-    /**
-     * @brief Less than operator for comparing sequence numbers
-     * @param other sequence number to compare to this sequence number
-     * @returns true if this sequence number is less than other
-     */
-    bool operator<(const SequenceNumber<NUMERIC_TYPE, SIGNED_TYPE>& other) const
-    {
-        return !this->operator>(other) && m_value != other.m_value;
+        if (m_value == other.m_value)
+        {
+            return std::strong_ordering::equivalent;
+        }
+        if (((m_value > other.m_value) && (m_value - other.m_value) <= halfMaxValue) ||
+            ((other.m_value > m_value) && (other.m_value - m_value) > halfMaxValue))
+        {
+            return std::strong_ordering::greater;
+        }
+        return std::strong_ordering::less;
     }
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/nix-vector-routing/model/nix-vector-routing.h ns-3.47/src/nix-vector-routing/model/nix-vector-routing.h
--- ns-3.46/src/nix-vector-routing/model/nix-vector-routing.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/nix-vector-routing/model/nix-vector-routing.h	2026-02-16 16:08:49.807230700 -0800
@@ -71,9 +71,6 @@
     /// Alias for Ipv4Route and Ipv6Route classes
     using IpRoute = typename std::conditional_t<IsIpv4, Ipv4Route, Ipv6Route>;
 
-    /// Alias for Ipv4AddressHash and Ipv6AddressHash classes
-    using IpAddressHash = typename std::conditional_t<IsIpv4, Ipv4AddressHash, Ipv6AddressHash>;
-
     /// Alias for Ipv4Header and Ipv6Header classes
     using IpHeader = typename std::conditional_t<IsIpv4, Ipv4Header, Ipv6Header>;
 
@@ -499,7 +496,7 @@
      * GetNodeByIp() method.  NIX vector routing assumes IP addresses
      * are unique so mapping can be done without duplication.
      **/
-    typedef std::unordered_map<IpAddress, ns3::Ptr<ns3::Node>, IpAddressHash> IpAddressToNodeMap;
+    typedef std::unordered_map<IpAddress, ns3::Ptr<ns3::Node>> IpAddressToNodeMap;
     static IpAddressToNodeMap g_ipAddressToNodeMap; //!< Address to node map.
 
     /// Mapping of Ptr<NetDevice> to Ptr<IpInterface>.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/olsr/model/olsr-routing-protocol.cc ns-3.47/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.46/src/olsr/model/olsr-routing-protocol.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/olsr/model/olsr-routing-protocol.cc	2026-02-16 16:08:49.808230600 -0800
@@ -88,12 +88,6 @@
 /// Maximum number of messages per packet.
 #define OLSR_MAX_MSGS 64
 
-/// Maximum number of hellos per message (4 possible link types * 3 possible nb types).
-#define OLSR_MAX_HELLOS 12
-
-/// Maximum number of addresses advertised on a message.
-#define OLSR_MAX_ADDRS 64
-
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/openflow/CMakeLists.txt ns-3.47/src/openflow/CMakeLists.txt
--- ns-3.46/src/openflow/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/openflow/CMakeLists.txt	2026-02-16 16:08:49.809230800 -0800
@@ -48,7 +48,10 @@
   return()
 endif()
 
-include_directories(${openflow_INCLUDE_DIRS})
+include_directories(
+  SYSTEM
+  ${openflow_INCLUDE_DIRS}
+)
 add_definitions(
   -DNS3_OPENFLOW
   -DENABLE_OPENFLOW
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/openflow/helper/openflow-switch-helper.cc ns-3.47/src/openflow/helper/openflow-switch-helper.cc
--- ns-3.46/src/openflow/helper/openflow-switch-helper.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/openflow/helper/openflow-switch-helper.cc	2026-02-16 16:08:49.809230800 -0800
@@ -48,7 +48,7 @@
     NS_LOG_INFO("**** Set up Controller");
     dev->SetController(controller);
 
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         NS_LOG_INFO("**** Add SwitchPort " << *i);
         dev->AddSwitchPort(*i);
@@ -67,7 +67,7 @@
     devs.Add(dev);
     node->AddDevice(dev);
 
-    for (NetDeviceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         NS_LOG_INFO("**** Add SwitchPort " << *i);
         dev->AddSwitchPort(*i);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/cost231-propagation-loss-model.cc ns-3.47/src/propagation/model/cost231-propagation-loss-model.cc
--- ns-3.46/src/propagation/model/cost231-propagation-loss-model.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/cost231-propagation-loss-model.cc	2026-02-16 16:08:49.811230700 -0800
@@ -39,7 +39,7 @@
                           MakeDoubleAccessor(&Cost231PropagationLossModel::m_lambda),
                           MakeDoubleChecker<double>())
             .AddAttribute("Frequency",
-                          "The Frequency  (default is 2.3 GHz).",
+                          "Carrier Frequency.",
                           DoubleValue(2.3e9),
                           MakeDoubleAccessor(&Cost231PropagationLossModel::m_frequency),
                           MakeDoubleChecker<double>())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/propagation/model/cost231-propagation-loss-model.h ns-3.47/src/propagation/model/cost231-propagation-loss-model.h
--- ns-3.46/src/propagation/model/cost231-propagation-loss-model.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/propagation/model/cost231-propagation-loss-model.h	2026-02-16 16:08:49.811230700 -0800
@@ -35,6 +35,12 @@
  *  Base station Antenna Height: 30m to 200m
  *  Link Distance:up to 20 km
  *
+ *  @note Although the classical COST-231 model has been empirically validated
+ *  in the 1500 MHz to 2000 MHz frequency range, the ns-3 implementation
+ *  historically defaults to 2.3 GHz due to its original use in WiMAX studies.
+ *  Users are advised to consciously select the carrier frequency appropriate
+ *  for their scenario and to exercise caution when operating far outside the
+ *  classical validity range.
  */
 
 class Cost231PropagationLossModel : public PropagationLossModel
